import numpy as np
import cv2
from matplotlib import pyplot as plt


def myBilateralFilter(I, size, sigmaColor, sigmaSpace):
    J = I # remove this line

    # write your code here

    # here, J is supposed to be the the filtered image 
    return J


# test the filters

# read image
I = cv2.imread('isfahan.jpg').astype(np.float32) / 255;

noise_sigma = .1
N = np.random.randn(*I.shape) * noise_sigma

# noisy image
In = I + N.astype(np.float32);

size = 9
sigmaColor = 0.3
sigmaSpace = 75

# filter linearly with a Gaussian Kernel
Jg = cv2.GaussianBlur(In, (size, size), sigmaSpace)


# filter with OpenCV bilateralFilter
Jb = cv2.bilateralFilter(In,size, sigmaColor, sigmaSpace)

# filter with your own Bilateral Filter
Jm = myBilateralFilter(In,size, sigmaColor, sigmaSpace)


fig, axes = plt.subplots(2, 3, subplot_kw=dict(polar=True))



# display result
image_list = [I, In, Jg, Jb, Jm]
title_list = ["Original Image",
              "Noisy Image",
              "Gaussian Filter",
              "OpenCV Bilateral Filter",
              "My Bilateral Filter"]


for K, t in zip(image_list, title_list):
    cv2.imshow(t,K)
    cv2.waitKey()






